/* Entete {{{1

* @progname	16quart
* @version 	2.0 (14.01.2011)
* @author 	Patrick Texier (p.texier@orsennes.com)
* @category
* @output 	Text
* @description

Édition d'arbres 16 quartiers en série

   }}}1 */
/* Déclarations {{{1*/
global(cadre) /* table ligne -> cadre */
global(sosa) /* table ligne -> sosa */
global(case) /* table sosa des personnes de l'arbre */
global(traite) /* table des arbres déjà traités */
global(convsosa)
global(couple)
global(crindex) /* Création d'un index ? */
global(lastindex) /* Dernier patronyme de l'index */

global(indiv)
global(ilist)
global(alist)
global(aflist)
global(glist)

global(ahnen)

global(tableau) /* Tableau en cours */

global(cptarbres)
global(allindi) /* indiset de toutes les personnes */
global(detindex)

global(html) /* mode html ? */
/* }}}1 */
proc main () /* {{{1 */
{
	set(html, 0)
	if(html) {
		newfile("16quart.html", 0)
		call entete_html()
	}
	else {
		newfile("16quart.txt", 0)
	}
	set(crindex, 1)
	call init()
	call imp_joannis("E54")
	if(html) {
		call pied_html()
	}
} /* }}} 1 */
proc imp_joannis(cle) /* {{{1 */
{

	/* TODO C'est pour le moment en dur */

	"                  LES SEIZE QUARTIERS GÉNÉALOGIQUES\n" 
	"                            DES CAPÉTIENS\n\n"
	"Édition actualisée de l'ouvrage du comte Jean-Dominique de Joannis paru entre\n"
	"1958 et 1965. Les tableaux ajoutés reprennent le numéro de la planche de\n"
	"l'ancêtre capétien dont ils sont issus suivi de / et d'un compteur (ex :\n"
	"291/002).\n\n"
	"La saisie est loin d'être achevée.\n\n"
	if(html) {
		"<hr>"
		"<a href=" qt() "#INDEX" qt() ">INDEX</a>"
		"<hr>"
	}
	else {
		"────────────────────────────────────────────────────────────────────────────────\n"
	}
	"SOMMAIRE\n\n"
	table(arbrestable)
	foreven(myeven, cpt) /* Impression du sommaire {{{2 */
	{
		if(eqstr(key(myeven), cle)) {
			set(lasttag, "")
			traverse(myeven, mynode, niveau) {
				if(eqstr(tag(mynode), "_CHA")) {
					if(html) {
						"\nCHAPITRE <a href=" qt() "#C" value(mynode) qt()">"
						value(mynode) "</a> : "
					}
					else {
						"\nCHAPITRE " value(mynode) " : "
					}
				}
				elsif(eqstr(tag(mynode), "TITL")) {
					if(not(eqstr(lasttag, "_CHA"))) {
						"\n"
					}
					upper(value(mynode))
					"\n\n"
				}
				elsif(eqstr(tag(mynode), "_TAB")) {
					set(tableau, value(mynode))
					if(eq(substring(tableau, 1, 2), "cf")) {
						set(noprint, 1)
					}
					else {
						set(noprint, 0)
					}
				}
				elsif(eqstr(tag(mynode), "INDI")) {
					set(decujus, indi(value(mynode)))
					/* TODO */
					if(noprint) {
						"-\t"
					}
					else {
						if(html) {
							"<a href=" qt() "#P" tableau qt() ">" tableau "</a>\t"
						}
						else {
							tableau "\t"
						}
					}
					call affnom(decujus, 0)
					" " call datesarbre(decujus)
					if(noprint) {
						if(html) {
							" "
							set(lien, substring(tableau, 4, strlen(tableau)))
							"<a href=" qt() "#P" lien qt() ">"
							tableau "</a>"
						}
						else {
							" " tableau 
						}
					}
					"\n"
				}
				set(lasttag, tag(mynode))
			}
		}
	} /* }}}2 */
	table(arbrestable)
	if(html) {
		"<hr>"
	}
	else {
		"────────────────────────────────────────────────────────────────────────────────"
	}
	"\n\nTABLEAUX DES SEIZE QUARTIERS\n\n"
	foreven(myeven, cpt) /* Impression des arbres {{{2 */
	{
		if(eqstr(key(myeven), cle)) {
			traverse(myeven, mynode, niveau) {
				if(eqstr(tag(mynode), "_TAB")) {
					set(basesosa, 1)
					set(tableau, value(mynode))
					if(eq(substring(tableau, 1, 2), "cf")) {
						set(noprint, 1)
					}
					else {
						set(noprint, 0)
					}
				}
				elsif(eqstr(tag(mynode), "_CHA")) {
					if(html) {
						"<a name=" qt() "C" value(mynode) qt() "</a>"
					}
				}
				elsif(eqstr(tag(mynode), "_SOSA")) {
					set(basesosa, strtoint(value(mynode)))
				}
				elsif(eqstr(tag(mynode), "INDI")) {
					set(decujus, indi(value(mynode)))
					/* TODO */
					/* print(concat(name(decujus), "\n")) */
					if(noprint) {
						call affnom(decujus, 0)
						" " call datesarbre(decujus)
						", planche "
						if(html) {
							set(lien, substring(tableau, 4, strlen(tableau)))
							"<a href=" qt() "#P" lien qt() ">"
							tableau "</a>"
						}
						else {
							tableau
						}
						"\n\n"
					}
					else {
						if(html) {
							"<a name=" qt() "P" tableau qt() "</a>"
						}
						"PLANCHE " tableau " - " 
						call affnom(decujus, 0)
						" " call datesarbre(decujus)
						"\n\n"

						set(par, parents(decujus))
						if(par) {
							set(clearbre, lookup(arbrestable, key(par)))
							if(clearbre) {
								if(html) {
									"= planche <a href=" qt() "#P" clearbre qt()
									">" clearbre "</a>\n\n"
								}
								else {
									"= planche " clearbre "\n\n"
								}
							}
							else {
								insert(arbrestable, key(par), tableau)
							}
						}
						call arbre(decujus, basesosa)
					}
				}
			}
		}
	} /* }}}2 */
	"\n\n" d(length(allindi)) " personnes dans " d(cptarbres) " arbres.\n"
	if(crindex) {
		call imp_index()
	}
} /* }}}1 */
proc imp_index() /* {{{1 */
{

	if(html) {
		"<hr><a name=" qt() "INDEX" qt() "</a>\n"
	}
	else {
		"────────────────────────────────────────────────────────────────────────────────"
	}
	"\n\nINDEX\n\n"
	if(html) {
		"</pre>\n<ul>"
	}
	namesort(allindi)
	set(lastindex, "zzz")
	forindiset(allindi, indiv, val, bidon) {
		call affnom(indiv, 1) " "
		call datesarbre(indiv)
		set(ligne, lookup(detindex, key(indiv)))
		" " ligne 
		if(not(html)) {
			"\n"
		}
	}
	if(html) {"</ul>\n</ul>\n"}
}
/* }}}1 */
proc arbre(indiv, basesosa) /* {{{1 */
{
	incr(cptarbres)
	set(un_cadre, "")
	list(ilist)
	list(alist)
	list(aflist)
	list(glist)
	list(plist)
	table(case)
	table(couple)
	table(convsosa)
	enqueue(ilist, indiv)
	enqueue(alist, 1)
	enqueue(aflist, basesosa)
	enqueue(glist, 1)
	/* chargement des personnes {{{2 */
	while(indiv, dequeue(ilist)) {

		set(ahnen, dequeue(alist))
		set(ahnen2, dequeue(aflist))
		set(gene, dequeue(glist))
		if(gt(gene, 1)) {
			set(cpl, dequeue(plist))
			insert(couple, d(ahnen), cpl)
		}
		insert(case, d(ahnen), indiv)
		insert(convsosa, d(ahnen), d(ahnen2))
		/* Gestion de l'index */
		if(not(lookup(traite, tableau))) {
			if(crindex) {
				if(html) {
					set(entindex, concat("<a href=", qt(), "#P", tableau, qt(),
								">",tableau, "-", d(ahnen2), "</a>"))
				}
				else {
					set(entindex, concat(tableau, "-", d(ahnen2)))
				}
			}
			if(not(inset(allindi, indiv))) {
				addtoset(allindi, indiv, key(indiv))
				if(crindex) {
					insert(detindex, key(indiv), entindex)
				}
			}
			elsif(crindex) {
				set(bidon, lookup(detindex, key(indiv)))
				set(bidon, concat(bidon, ", ", entindex))
				insert(detindex, key(indiv), bidon)
			}
		}
		if(lt(gene, 5)) {
			/* On stocke le père */
			if(par, father(indiv)) {
				enqueue(ilist, par)
				enqueue(alist, mul(ahnen, 2))
				enqueue(aflist, mul(ahnen2, 2))
				enqueue(glist, add(gene, 1))
			}
			/* on stocke la mère */
			if(par, mother(indiv)) {
				enqueue(ilist, par)
				enqueue(alist, add(mul(ahnen, 2), 1))
				enqueue(aflist, add(mul(ahnen2, 2), 1))
				enqueue(glist, add(gene, 1))
			}
			/* on stocke le couple de parents */
			if(par, parents(indiv)) {
				enqueue(plist, par)
				enqueue(plist, par)
			}
		}
	}
	insert(traite, tableau, 1)
	/* }}} 2*/
	/* impression de l'arbre {{{2 */
	set(ligne, 1)
	while(le(ligne, 31)) {
		set(ahnen, lookup(sosa, d(ligne)))
		if(indiv, lookup(case, ahnen)) {
			set(ahnen2, lookup(convsosa, ahnen))
			set(un_cadre, lookup(cadre, d(ligne)))
			un_cadre ahnen2 " "
			call affnom(indiv, 0) " "
			call datesarbre(indiv)
			/* date de mariage si homme */
			if(eqstr(sex(indiv), "M")) {
				set(cpl, lookup(couple, ahnen))
				call datemar(cpl)
			}	
			" [" key(indiv) "]"
			"\n"
		}
		incr(ligne)
	}
	"\n"
	/* }}}2 */
}
/* }}}1 */
proc affnom(indiv, modeindex) /* {{{1 */
{
	set(prenom, givens(indiv))
	set(nom, surname(indiv))
	set(titre, title(indiv))
	set(tit, "")
	set(domaine, "")
	set(nom2, "")
	set(domaine2, "")
	list(dectitre)
	if(modeindex) {
		if(nestr(nom, lastindex)) {
			if(and(html, nestr(lastindex, "zzz"))) {
				"</ul>"
			}
			set(lastindex, nom)
			if(html) {
				"<li>" nom "\n<ul><li>"
			}
			else {
				nom "\n  "
			}
		}
		else {
			if(html) {
				"<li>"
			}
			else {
				"  "
			}
		}
		set(nom, "")
	}
	if(nestr(titre, "")) {
		extracttokens(titre, dectitre, nbr, ",")
		set(tit, getel(dectitre, 1))
		if(gt(nbr, 1)) {
			set(domaine, getel(dectitre, 2))
			/* set(domaine, substring(domaine, 2, sub(strlen(domaine), 1))) */
		}
		if(eqstr(nom, domaine)) {
			set(nom, "")
		}
		elsif(eqstr(substring(nom, 1, 3), "de ")) {
			set(nom2, substring(nom, 4, strlen(nom)))
			if(eqstr(substring(domaine, 1, 3), "en ")) {
				set(domaine2, substring(domaine, 4, strlen(domaine)))
			}
			elsif(eqstr(substring(domaine, 1, 2), "à ")) {
				set(domaine2, substring(domaine, 3, strlen(domaine)))
			}
			if(eqstr(nom2, domaine2)) {
				set(nom, "")
			}
		}
	}
	prenom
	if(nestr(nom, "")) {
		" " nom
	}
	if(nestr(titre, "")) {
		" " tit " " domaine
	}
} /*}}}1*/
proc datesarbre(indiv) /* {{{1 */
{
	set(affdates, "")
	set(annee1, "")
	if(annee1, year(birth(indiv))) {
		set(date1, date(birth(indiv)))
	}
	elsif(annee1, year(baptism(indiv))) {
		set(date1, date(baptism(indiv)))
	}
	if(nestr(annee1, "")) {
		set (affdates, "(")
		if(eqstr(substring(date1, 1, 3), "BEF")) {
			set(affdates, concat(affdates, "av "))
		}
		if(or(eqstr(substring(date1, 1, 3), "ABT"),
					eqstr(substring(date1, 1, 3), "BET"))) {
			set(affdates, concat(affdates, "ca "))
		}
		if(eqstr(substring(date1, 1, 3), "AFT")) {
			set(affdates, concat(affdates, "ap "))
		}
		set(affdates, concat(affdates, annee1))
	}
	set(annee2, "")
	if(annee2, year(death(indiv))) {
		set(date2, date(death(indiv)))
	}
	elsif(annee2, year(burial(indiv))) {
		set(date2, date(burial(indiv)))
	}
	if(nestr(annee2, "")) {
		if(nestr(annee1, "")) {
			set(affdates, concat(affdates, "-"))
		}
		else {
			set(affdates, "(†")
		}
		if(eqstr(substring(date2, 1, 3), "BEF")) {
			set(affdates, concat(affdates, "av "))
		}
		if(or(eqstr(substring(date2, 1, 3), "ABT"),
					eqstr(substring(date2, 1, 3), "BET"))) {
			set(affdates, concat(affdates, "ca "))
		}
		if(eqstr(substring(date2, 1, 3), "AFT")) {
			set(affdates, concat(affdates, "ap "))
		}
		set(affdates, concat(affdates, annee2))
	}
	if(nestr(affdates, "")) { set(affdates, concat(affdates, ")")) }
	affdates
} /* }}}1 */
proc datemar(cpl) /* {{{1 */
{
	set(affdate, "")
	set(annee, "")
	if(annee, year(marriage(cpl))) {
		set(date1, date(marriage(indiv)))
	}
	if(nestr(annee, "")) {
		set (affdate, " × ")
		if(eqstr(substring(date1, 1, 3), "BEF")) {
			set(affdate, concat(affdate, "av "))
		}
		if(or(eqstr(substring(date1, 1, 3), "ABT"),
					eqstr(substring(date1, 1, 3), "BET"))) {
			set(affdate, concat(affdate, "ca "))
		}
		if(eqstr(substring(date1, 1, 3), "AFT")) {
			set(affdate, concat(affdate, "ap "))
		}
		set(affdate, concat(affdate, annee))
	}
	affdate
} /* }}}1 */
proc init() /* {{{1 */
{
	set(cptarbres, 0)
	indiset(allindi)
	table(detindex)
	table(traite)
	table(cadre) /* chargement de la table des cadres {{{2 */
	insert(cadre, "1", "             ┌─ ")
	insert(cadre, "2", "         ┌─ ")
	insert(cadre, "3", "         │   └─ ")
	insert(cadre, "4", "     ┌─ ")
	insert(cadre, "5", "     │   │   ┌─ ")
	insert(cadre, "6", "     │   └─ ")
	insert(cadre, "7", "     │       └─ ")
	insert(cadre, "8", " ┌─ ")
	insert(cadre, "9", " │   │       ┌─ ")
	insert(cadre, "10", " │   │   ┌─ ")
	insert(cadre, "11", " │   │   │   └─ ")
	insert(cadre, "12", " │   └─ ")
	insert(cadre, "13", " │       │   ┌─ ")
	insert(cadre, "14", " │       └─ ")
	insert(cadre, "15", " │           └─ ")
	insert(cadre, "16", "")
	insert(cadre, "17", " │           ┌─ ")
	insert(cadre, "18", " │       ┌─ ")
	insert(cadre, "19", " │       │   └─ ")
	insert(cadre, "20", " │   ┌─ ")
	insert(cadre, "21", " │   │   │   ┌─ ")
	insert(cadre, "22", " │   │   └─ ")
	insert(cadre, "23", " │   │       └─ ")
	insert(cadre, "24", " └─ ")
	insert(cadre, "25", "     │       ┌─ ")
	insert(cadre, "26", "     │   ┌─ ")
	insert(cadre, "27", "     │   │   └─ ")
	insert(cadre, "28", "     └─ ")
	insert(cadre, "29", "         │   ┌─ ")
	insert(cadre, "30", "         └─ ")
	insert(cadre, "31", "             └─ ")
	/* }}}2 */
	table(sosa) /* chargement de la table de l'ordre des sosa {{{2 */
	insert(sosa, "1", "16")
	insert(sosa, "2", "8")
	insert(sosa, "3", "17")
	insert(sosa, "4", "4")
	insert(sosa, "5", "18")
	insert(sosa, "6", "9")
	insert(sosa, "7", "19")
	insert(sosa, "8", "2")
	insert(sosa, "9", "20")
	insert(sosa, "10", "10")
	insert(sosa, "11", "21")
	insert(sosa, "12", "5")
	insert(sosa, "13", "22")
	insert(sosa, "14", "11")
	insert(sosa, "15", "23")
	insert(sosa, "16", "1")
	insert(sosa, "17", "24")
	insert(sosa, "18", "12")
	insert(sosa, "19", "25")
	insert(sosa, "20", "6")
	insert(sosa, "21", "26")
	insert(sosa, "22", "13")
	insert(sosa, "23", "27")
	insert(sosa, "24", "3")
	insert(sosa, "25", "28")
	insert(sosa, "26", "14")
	insert(sosa, "27", "29")
	insert(sosa, "28", "7")
	insert(sosa, "29", "30")
	insert(sosa, "30", "15")
	insert(sosa, "31", "31")
	/* }}}2 */
} /* }}}1 */
proc entete_html() /* {{{1 */
{
	"<!DOCTYPE HTML PUBLIC " qt() "-//W3C//DTD HTML 4.01 Transitional//EN" qt() ">\n"
	"<html>\n<head>\n"
	"<meta http-equiv=" qt() "Content-Type" qt() " content=" qt() "text/html; charset=utf-8" qt() ">\n"
	"<title>Les seize quartiers généalogiques des capétiens</title>\n"
	"</head>\n<body>\n"
	"<pre>\n"
} /* }}}1 */
proc pied_html() /* {{{1 */
{
	"<hr>\n"
	"<address>\n"
	"<p>Édition produite par <a href=" qt() "16quart-src.zip" qt() ">16quart.ll</a>, un rapport\n"
	"<a href=" qt() "http://lifelines.sourceforge.net" qt() ">LifeLines</a> "
	"écrit par <a href=" qt() "mailto:p.texier@orsennes.com" qt() ">Patrick Texier</a><br>"
	"Édité le 14.01.2010"
	"</address>\n"
	"</body>\n</html>\n"
} /* }}}1 */
/*
 vim: fdm=marker
*/
